import { ActionType, SemanticsType, } from "@sfroment/object";
export class AddMulDRP {
    semanticsType = SemanticsType.pair;
    _value = 0;
    add(value) {
        this._value += value;
    }
    mul(value) {
        this._value *= value;
    }
    query_value() {
        return this._value;
    }
    resolveConflicts(vertices) {
        if (vertices.length < 2 || vertices[0].hash === vertices[1].hash) {
            return { action: ActionType.Nop };
        }
        const [left, right] = vertices;
        const leftOp = left.operation?.opType ?? "";
        const rightOp = right.operation?.opType ?? "";
        const leftContent = left.operation?.value?.[0] ?? 0;
        const rightContent = right.operation?.value?.[0] ?? 0;
        if (leftOp === rightOp &&
            (left.peerId > right.peerId || (left.peerId === right.peerId && leftContent < rightContent))) {
            return { action: ActionType.Swap };
        }
        if (leftOp === "mul" && rightOp === "add") {
            return { action: ActionType.Swap };
        }
        return { action: ActionType.Nop };
    }
}
